{    This is just some quick demo code to show off the high-color-raster driver

     See the driver header for setting resolution.

     Set driver constants, then set the pixel values here.

     Default is low resolution 80x48 for testing.  Or call it a Fairchild Channel F
     driver on steroids!  

     Right now, there is no CLUT (color lookup table) in the video driver, so the
     values contained in the display buffer must make sense.  There is a CLUT here
     for your use, demonstrated in the quick 'n dirty pixel plot method.

     Due to RAM consumption, this is a single buffered display.  

}

CON
  ' Set up the processor clock in the standard way for 80MHz on HYDRA
  _CLKMODE = xtal1 + pll8x
  _XINFREQ = 10_000_000 + 0000

  HORIZONTAL_PIXELS = 80
  VERTICAL_PIXELS = 48

VAR
  byte          displayb[HORIZONTAL_PIXELS * VERTICAL_PIXELS]   'allocate display buffer in RAM
                                  
  long          index             'temp offset for byte statement below

  long          i, j, k, l, m     'misc working vars

OBJ
  tv : "potatohead--hi-color-raster-variable-resolution_01_TV"  'the TV driver
  
PUB start |  c, o, d, p

   'fill bitmap with valid pixels, before triggering display there is no Color Lookup
   'Table in the TV driver just yet.
   
    repeat index from 0 to (HORIZONTAL_PIXELS * VERTICAL_PIXELS) 
      byte [@displayb] [index] := @@clut[2]  'There is a CLUT in this program though
        
    tv.start(@displayb)  'start the tv cog & pass it the address of the bitmap

    'I've left the 400 color artifacting code in here.  Just fixed dot plotter so that no pixel
    'plots outside the screen memory area.  Changes in resolution will reveal more of the
    'display.   
     

    repeat j from 10 to 29  

        repeat k from 0 to 19 
           
           c := (k // 5) + 1
           repeat l from (j*8) to (j*8) + 7 step 2
             
             repeat m from (k*3) to (k*3)+ 2

    'Comment out one or the other of these lines, and uncomment a matching one to see
    'each palette without being added to the other.  This is also useful for seeing what
    'hues you should be watching for.
                                                                         
                     plot(l,m, (((29 - j) // 5 + 1) + ((j-10)/5)*8) +((k/5)*32) )  
                     'plot(l+1,m,(((29 - j) // 5 + 1) + ((j-10)/5)*8) +((k/5)*32))
                     
                     plot(l+1,m, c+(((j-10)/5)*8)+((k/5)*32))
                     'plot(l,m, c+(((j-10)/5)*8)+((k/5)*32))


     'Additional colors are possible using the high-saturation colors.  Not shown.

                    
    'plot standard prop color set these are mapped in the CLUT below.
    
    o := -1
    repeat k from 30 to 30+256 step 2
      o := o + 1
       repeat j from 70 to 95
         plot(k, j, o)
         plot(k+1, j, o)

    
    plot(10, 0, 4)  'just a test pixel 
    plot(11, 1, 7)
    plot(78, 47, 7)

    repeat k from 2 to 30 'coupla lines to show vertical resolution
      plot(k,k+8, 5)
      plot(k,k+12, 4)
      plot(k,k+16, 3)
      plot(k,k+20, 1)
      plot(k,k+22, 0)

    'Draw screen border

    repeat k from 0 to HORIZONTAL_PIXELS - 1
      plot (k, 0, 7)
      plot (k, VERTICAL_PIXELS -1, 7)

    repeat k from 0 to VERTICAL_PIXELS - 1
      plot (0, k, 7)
      plot (HORIZONTAL_PIXELS, k, 7)
        
pub plot(x,y,c)
  'very simple dot plotter
  'one byte per pixel is sweet!

  'c := c & %0111 'uncomment for monochrome display only

  'keep things sane
  x := x // HORIZONTAL_PIXELS
  y := y // VERTICAL_PIXELS
    
  displayb[y*HORIZONTAL_PIXELS+x] := @@clut[c & %01111111]   '128 color CLUT

DAT

'Two Color tables here.  This commented one has the lowest intensity of each
'possible hue mapped to the low intensity color instead of the lowest intensity
'color.  Some televisions do not play well with these when they occupy large areas
'of the screen.  I've not had any trouble with mixed colors that incorporate these
'however.  YMMV.

'color lookup table, upper 4 bits hue, lower 4 intensity and saturation
'mixed together.  I've got the high saturation colors mapped to their
'closest hue.  They are the last two entries.

'I am including these as they make life easy with the standard propeller colors
'
'Ideally, a high color display will have these mappings crafted for 8 bit color
'such that the graphics generate code can then just ask for a color, instead of
'doing the tedious dot plotting I'm doing here for demonstration / proof of technique

{
clut
clut0   byte  byte  $02, $03, $04, $05, $06, $07, $07, $07
clut1   byte  byte  $1a, $1a, $1b, $1c, $1d, $1e, $98, $af
clut2   byte  byte  $2a, $2a, $2b, $2c, $2d, $2e, $a8, $bf
clut3   byte  byte  $3a, $3a, $3b, $3c, $3d, $3e, $b8, $cf
clut4   byte  byte  $4a, $4a, $4b, $4c, $4d, $4e, $c8, $df
clut5   byte  byte  $5a, $5a, $5b, $5c, $5d, $5e, $d8, $ef
clut6   byte  byte  $6a, $6a, $6b, $6c, $6d, $6e, $e8, $ff
clut7   byte  byte  $7a, $7a, $7b, $7c, $7d, $7e, $f8, $0f
clut8   byte  byte  $8a, $8a, $8b, $8c, $8d, $8e, $08, $1f
clut9   byte  byte  $9a, $9a, $9b, $9c, $9d, $9e, $18, $2f
cluta   byte  byte  $aa, $aa, $ab, $ac, $ad, $ae, $28, $3f
clutb   byte  byte  $ba, $ba, $bb, $bc, $bd, $be, $38, $4f
clutc   byte  byte  $ca, $ca, $cb, $cc, $cd, $ce, $48, $5f
clutd   byte  byte  $da, $da, $db, $dc, $dd, $de, $58, $6f
clute   byte  byte  $ea, $ea, $eb, $ec, $ed, $ee, $68, $7f
clutf   byte  byte  $fa, $fa, $fb, $fc, $fd, $fe, $78, $8f}


'  Unmodified CLUT below --use at
'  your own risk!  This one includes the low intensity colors.

clut
clut0   byte  byte  $02, $03, $04, $05, $06, $07, $07, $07
clut1   byte  byte  $19, $1a, $1b, $1c, $1d, $1e, $98, $af
clut2   byte  byte  $29, $2a, $2b, $2c, $2d, $2e, $a8, $bf
clut3   byte  byte  $39, $3a, $3b, $3c, $3d, $3e, $b8, $cf
clut4   byte  byte  $49, $4a, $4b, $4c, $4d, $4e, $c8, $df
clut5   byte  byte  $59, $5a, $5b, $5c, $5d, $5e, $d8, $ef
clut6   byte  byte  $69, $6a, $6b, $6c, $6d, $6e, $e8, $ff
clut7   byte  byte  $79, $7a, $7b, $7c, $7d, $7e, $f8, $0f
clut8   byte  byte  $89, $8a, $8b, $8c, $8d, $8e, $08, $1f
clut9   byte  byte  $99, $9a, $9b, $9c, $9d, $9e, $18, $2f
cluta   byte  byte  $a9, $aa, $ab, $ac, $ad, $ae, $28, $3f
clutb   byte  byte  $b9, $ba, $bb, $bc, $bd, $be, $38, $4f
clutc   byte  byte  $c9, $ca, $cb, $cc, $cd, $ce, $48, $5f
clutd   byte  byte  $d9, $da, $db, $dc, $dd, $de, $58, $6f
clute   byte  byte  $e9, $ea, $eb, $ec, $ed, $ee, $68, $7f
clutf   byte  byte  $f9, $fa, $fb, $fc, $fd, $fe, $78, $8f